<?php
class ControllerModuleTargetsms extends Controller {
	private $error = array();

	public function index() {
		$this->language->load('module/targetsms');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');
		$this->load->model('setting/store');
		$this->load->model('localisation/order_status');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

			foreach ($this->request->post['stores'] as $key => $store) {

				$this->model_setting_setting->editSetting('targetsms', $store, $key);
				
			}
			
			

			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], true));
		}

		$this->data['action'] = $this->url->link('module/targetsms', 'token=' . $this->session->data['token'], true);
		$this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], true);

		$this->data['token'] = $this->session->data['token'];

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_edit'] = $this->language->get('text_edit');
		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_loading'] = $this->language->get('text_loading');
        $this->data['text_confirm'] = $this->language->get('text_confirm');
		$this->data['text_phone_placeholder'] = $this->language->get('text_phone_placeholder');

		$this->data['tab_connect'] = $this->language->get('tab_connect');
		$this->data['tab_test'] = $this->language->get('tab_test');
		$this->data['tab_admin'] = $this->language->get('tab_admin');
		$this->data['tab_customer'] = $this->language->get('tab_customer');
		$this->data['tab_history'] = $this->language->get('tab_history');

		$this->data['entry_targetsms_login'] = $this->language->get('entry_targetsms_login');
		$this->data['entry_targetsms_password'] = $this->language->get('entry_targetsms_password');
		$this->data['entry_targetsms_from'] = $this->language->get('entry_targetsms_from');
		$this->data['entry_targetsms_balance'] = $this->language->get('entry_targetsms_balance');
		$this->data['entry_targetsms_store'] = $this->language->get('entry_targetsms_store');
		$this->data['entry_targetsms_to'] = $this->language->get('entry_targetsms_to');
		$this->data['entry_targetsms_admin_send'] = $this->language->get('entry_targetsms_admin_send');
		$this->data['entry_targetsms_admin_template'] = $this->language->get('entry_targetsms_admin_template');
		$this->data['entry_targetsms_admin_template_defaul'] = $this->language->get('entry_targetsms_admin_template_defaul');
		$this->data['entry_targetsms_customer_send'] = $this->language->get('entry_targetsms_customer_send');
		$this->data['entry_targetsms_customer_order_status'] = $this->language->get('entry_targetsms_customer_order_status');
		$this->data['entry_targetsms_customer_templates'] = $this->language->get('entry_targetsms_customer_templates');
		$this->data['entry_targetsms_customer_order_status_template_defaul'] = $this->language->get('entry_targetsms_customer_order_status_template_defaul');
		$this->data['entry_date_send_start'] = $this->language->get('entry_date_send_start');
		$this->data['entry_date_send_stop'] = $this->language->get('entry_date_send_stop');
		$this->data['entry_sms_status']	= $this->language->get('entry_sms_status');
		$this->data['entry_sms_status_deliver']	= $this->language->get('entry_sms_status_deliver');
		$this->data['entry_sms_status_partly_deliver']	= $this->language->get('entry_sms_status_partly_deliver');
		$this->data['entry_sms_status_expired']	= $this->language->get('entry_sms_status_expired');
		$this->data['entry_sms_status_not_deliver']	= $this->language->get('entry_sms_status_not_deliver');
		$this->data['entry_targetsms_test_phone']	= $this->language->get('entry_targetsms_test_phone');
		$this->data['entry_targetsms_test_message']	= $this->language->get('entry_targetsms_test_message');

		$this->data['entry_history_sms_id']	= $this->language->get('entry_history_sms_id');
		$this->data['entry_history_sms_sender']	= $this->language->get('entry_history_sms_sender');
		$this->data['entry_history_sms_recipient']	= $this->language->get('entry_history_sms_recipient');
		$this->data['entry_history_sms_text']	= $this->language->get('entry_history_sms_text');
		$this->data['entry_history_sms_status']	= $this->language->get('entry_history_sms_status');
		$this->data['entry_history_sms_date']	= $this->language->get('entry_history_sms_date');

		$this->data['help_targetsms_to'] = $this->language->get('help_targetsms_to');
		$this->data['help_targetsms_admin_template'] = $this->language->get('help_targetsms_admin_template');
		$this->data['help_targetsms_customer_order_status'] = $this->language->get('help_targetsms_customer_order_status');
		$this->data['help_targetsms_customer_template'] = $this->language->get('help_targetsms_customer_template');
		$this->data['help_targetsms_test_phone'] = $this->language->get('help_targetsms_test_phone');

	
		$this->data['button_filter'] = $this->language->get('button_filter');
		$this->data['button_connect'] = $this->language->get('button_connect');
		$this->data['button_send'] = $this->language->get('button_send');
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

		if (isset($this->error['name'])) {
			$this->data['error_name'] = $this->error['name'];
		} else {
			$this->data['error_name'] = '';
		}

		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       		'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => false
   		);

		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
		);

		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/targetsms', 'token=' . $this->session->data['token'], 'SSL'),
      		'separator' => ' :: '
		);

		$this->data['stores'] = array();
		$this->data['stores'][] = array(
			'store_id' => 0,
			'name' => $this->language->get('entry_targetsms_store_default')
		);

		$stores = $this->model_setting_store->getStores();



		foreach ($stores as $key => $store) {
			$this->data['stores'][] = array(
				'store_id' => $store['store_id'],
				'name' => $store['name']
			);
		}

		foreach ($this->data['stores'] as $key => $store) {

			if (isset($this->request->post['stores'][$key]['targetsms_login'])) {
		    	$this->data['stores'][$key]['targetsms_login'] = $this->request->post['stores'][$key]['targetsms_login'];
		    } else {
		    	$this->data['stores'][$key]['targetsms_login'] = $this->model_setting_setting->getSettingValue('targetsms_login',$store['store_id']);
		    }
		    if (isset($this->request->post['stores'][$key]['targetsms_password'])) {
		    	$this->data['stores'][$key]['targetsms_password'] = $this->request->post['stores'][$key]['targetsms_password'];
		    } else {
		    	$this->data['stores'][$key]['targetsms_password'] = $this->model_setting_setting->getSettingValue('targetsms_password',$store['store_id']);
		    }
		    if (isset($this->request->post['stores'][$key]['targetsms_from'])) {
		    	$this->data['stores'][$key]['targetsms_from'] = $this->request->post['stores'][$key]['targetsms_from'];
		    } else {
		    	$this->data['stores'][$key]['targetsms_from'] = $this->model_setting_setting->getSettingValue('targetsms_from',$store['store_id']);
		    }

		    if ($this->data['stores'][$key]['targetsms_login'] && $this->data['stores'][$key]['targetsms_password']) {
		    	$this->data['stores'][$key]['senders'] = $this->getSenders($this->data['stores'][$key]['targetsms_login'],$this->data['stores'][$key]['targetsms_password']);
		    	$this->data['stores'][$key]['balance'] = $this->getBalance($this->data['stores'][$key]['targetsms_login'],$this->data['stores'][$key]['targetsms_password']);	
		    	if (!$this->data['stores'][$key]['balance']) {
		    		$this->data['stores'][$key]['balance'] = '0.00';
		    	} 
		    } else {
		    	$this->data['stores'][$key]['senders'] = array();
		    	$this->data['stores'][$key]['balance'] = '0.00';
		    }

		    $this->data['stores'][$key]['balance'] = $this->data['stores'][$key]['balance'] . " руб.";

		    if (isset($this->request->post['stores'][$key]['targetsms_to'])) {
		    	$this->data['stores'][$key]['targetsms_to'] = $this->request->post['stores'][$key]['targetsms_to'];
		    } else {
		    	$this->data['stores'][$key]['targetsms_to'] = $this->model_setting_setting->getSettingValue('targetsms_to',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['targetsms_admin_send'])) {
		    	$this->data['stores'][$key]['targetsms_admin_send'] = $this->request->post['stores'][$key]['targetsms_admin_send'];
		    } else if ($this->model_setting_setting->getSettingValue('targetsms_admin_send',$store['store_id'])) {
		    	$this->data['stores'][$key]['targetsms_admin_send'] = $this->model_setting_setting->getSettingValue('targetsms_admin_send',$store['store_id']);
		    } else {
		    	$this->data['stores'][$key]['targetsms_admin_send'] = '';
		    }

		    if (isset($this->request->post['stores'][$key]['targetsms_admin_template'])) {
		    	$this->data['stores'][$key]['targetsms_admin_template'] = $this->request->post['stores'][$key]['targetsms_admin_template'];
		    } else {
		    	$this->data['stores'][$key]['targetsms_admin_template'] = $this->model_setting_setting->getSettingValue('targetsms_admin_template',$store['store_id']);
		    }

		    if (isset($this->request->post['stores'][$key]['targetsms_customer_order_status'])) {
				$this->data['stores'][$key]['targetsms_customer_order_status'] = $this->request->post['stores'][$key]['targetsms_customer_order_status'];
			} elseif ($this->model_setting_setting->getSettingValue('targetsms_customer_order_status',$store['store_id'])) {
				$this->data['stores'][$key]['targetsms_customer_order_status'] =  unserialize($this->model_setting_setting->getSettingValue('targetsms_customer_order_status',$store['store_id']));
			} else {
				$this->data['stores'][$key]['targetsms_customer_order_status'] = array();
			}

		    if (isset($this->request->post['stores'][$key]['targetsms_customer_order_status_template'])) {
				$this->data['stores'][$key]['targetsms_customer_order_status_template'] = $this->request->post['stores'][$key]['targetsms_customer_order_status'];
			} elseif ($this->model_setting_setting->getSettingValue('targetsms_customer_order_status_template',$store['store_id'])) {
				$this->data['stores'][$key]['targetsms_customer_order_status_template'] =  unserialize($this->model_setting_setting->getSettingValue('targetsms_customer_order_status_template',$store['store_id']));
			} else {
				$this->data['stores'][$key]['targetsms_customer_order_status_template'] = array();
			}

		    //var_dump($this->data['stores'][$key]['targetsms_customer_order_status_template']);exit;
			
		}


		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		

		$this->document->addStyle('view/stylesheet/targetsms.css');
	    //CKEditor
	    if ($this->config->get('config_editor_default')) {
	        $this->document->addScript('view/javascript/ckeditor/ckeditor.js');
	        $this->document->addScript('view/javascript/ckeditor/ckeditor_init.js');
	    }

		$this->data['ckeditor'] = $this->config->get('config_editor_default');

		$this->data['lang'] = $this->language->get('lang');

	

		$this->template = 'module/targetsms.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
				
		$this->response->setOutput($this->render());

	}

	public function connect() {

		$json = $this->getSenders($this->request->post['targetsms_login'],$this->request->post['targetsms_password']);

		

		$json['balance'] = $this->getBalance($this->request->post['targetsms_login'],$this->request->post['targetsms_password']);

		
		$this->response->setOutput(json_encode($json));
	}

	public function getSenders($login,$password) {
		$param = array(
            'security' => array('login' => $login, 'password' => $password),
            'type' => 'originator'
        );

        $param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        $result = json_decode($res, true);
        curl_close($ch);
     
        return $result;
	}

	public function getBalance($login,$password) {
        $param = array(
			'security' => array('login' => $login, 'password' => $password),
			'type' => 'balance'
		);


        $param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        $result = json_decode($res, true);
        curl_close($ch);

		if (isset($result['money']['value'])) {
			return $result['money']['value'];
		} else {
			return false;
		}
        
	}

	public function getMessages() {
		$param = array(
		 'security' => array('login' => $this->request->post['targetsms_login'], 'password' => $this->request->post['targetsms_password']),
		 'type' => 'list_stats',
		 'stats' => array('date_start' => date("Y-m-d",strtotime($this->request->post['date_start'])), 'date_stop' => date("Y-m-d",strtotime($this->request->post['date_stop'])), 'state' => $this->request->post['state'], 'originator' => $this->request->post['targetsms_from'])
		);

		/*$param = array(
		 'security' => array('login' => 'tsms', 'password' => '123'),
		 'type' => 'list_stats',
		 'stats' => array('date_start' => '2000-01-01', 'date_stop' => '2019-01-01', 'state' => 'not_deliver', 'originator' => 'target')
		);*/



		$param_json = json_encode($param, true);
        // JSON-документ
        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, true);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
        curl_setopt($ch, CURLOPT_URL, $href);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
        $res = curl_exec($ch);
        //$result = json_decode($res, true);
        curl_close($ch);

        //var_dump($result);exit;
        $this->response->setOutput($res);

	}

	public function orderSms() {
		$this->load->model('setting/setting');
		$targetsms_login = $this->model_setting_setting->getSettingValue('targetsms_login',$this->request->post['store_id']);
		$targetsms_password = $this->model_setting_setting->getSettingValue('targetsms_password',$this->request->post['store_id']);
		$targetsms_from = $this->model_setting_setting->getSettingValue('targetsms_from',$this->request->post['store_id']);
		$phone = $this->request->post['phone'];
		$phone = str_replace(")","",$phone);
		$phone = str_replace("(","",$phone);
		$phone = str_replace("-","",$phone);
		$phone = str_replace(" ","",$phone);
		$phone = str_replace("+","",$phone);

		$first_3 = substr($phone,0,3);
		$first_1 = substr($phone,0,1);
		$error = 0;

		if (($first_3 == '380') || ($first_3 == '375')) {
			$last = substr($phone,3);
			if (strlen($last) == 9) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}
			
		} elseif ($first_1 == '7') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}

		} elseif ($first_1 == '8') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+7" . $last;
			} else {
				$error = 1;
			}
		} else {
			$error = 1;
		}

		if (!$error) {

			$param = array(
				'security' => array('login' => $targetsms_login, 'password' => $targetsms_password),
				'type' => 'sms',
				'message' => array(
					array(
						'type' => 'sms',
						'name_delivery' => 'opencartorders2_0_sendmanualsms',
						'sender' => $targetsms_from,
						'text' => $this->request->post['message'],
						'abonent' => array(
							array('phone' => $phone, 'number_sms' => '1')
						)
					)
				)
			);
			
			$param_json = json_encode($param, true);
	        // JSON-документ
	        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
	        $ch = curl_init();
	        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	        curl_setopt($ch, CURLOPT_POST, true);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
	        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
	        curl_setopt($ch, CURLOPT_URL, $href);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	        $res = curl_exec($ch);
	        $result = json_decode($res, true);
	        curl_close($ch);
		} else {
			$result = array();
			$result['error'] = "Неверный формат номера";
		}
	
        $this->response->setOutput(json_encode($result));
		

	}

	public function testSms() {

		$phone = $this->request->post['phone'];
		$phone = str_replace(")","",$phone);
		$phone = str_replace("(","",$phone);
		$phone = str_replace("-","",$phone);
		$phone = str_replace(" ","",$phone);
		$phone = str_replace("+","",$phone);

		$first_3 = substr($phone,0,3);
		$first_1 = substr($phone,0,1);
		$error = 0;

		if (($first_3 == '380') || ($first_3 == '375')) {
			$last = substr($phone,3);
			if (strlen($last) == 9) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}
			
		} elseif ($first_1 == '7') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+" . $phone;
			} else {
				$error = 1;
			}

		} elseif ($first_1 == '8') {
			$last = substr($phone,1);
			if (strlen($last) == 10) {
				$phone = "+7" . $last;
			} else {
				$error = 1;
			}
		} else {
			$error = 1;
		}

		if (!$error) {
			$param = array(
				'security' => array('login' => $this->request->post['targetsms_login'], 'password' => $this->request->post['targetsms_password']),
				'type' => 'sms',
				'message' => array(
					array(
						'type' => 'sms',
						'name_delivery' => 'opencartorders2_0_sendmanualsms',
						'sender' => $this->request->post['targetsms_from'],
						'text' => $this->request->post['message'],
						'abonent' => array(
							array('phone' => $phone, 'number_sms' => '1')
						)
					)
				)
			);
			$param_json = json_encode($param, true);
	        // JSON-документ
	        $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
	        $ch = curl_init();
	        curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
	        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	        curl_setopt($ch, CURLOPT_POST, true);
	        curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
	        curl_setopt($ch, CURLOPT_TIMEOUT, 600);
	        curl_setopt($ch, CURLOPT_URL, $href);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	        curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	        $res = curl_exec($ch);
	        $result = json_decode($res, true);
	        curl_close($ch);
		} else {
			$result = array();
			$result['error'] = "Неверный формат номера";
		}
	
        $this->response->setOutput(json_encode($result));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'module/targetsms')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}

    
}