<?php

final class Targetsms extends SmsGate {
    public function send() {

        $phones = explode(",",$this->to);
        
        $abonent = array();
        $number_sms = 0;
        $telephones = array();
        foreach ($phones as $key => $phone) {

            $phone = $this->validatePhone($phone);            
            if ($phone && !in_array($phone,$telephones)) {
                $number_sms++;
                $telephones[] = $phone;
                $abonent[] = array(
                    'phone' => $phone,
                    'number_sms' => $number_sms
                );
            }
        } 

        if ($this->use) {
            $name_delivery = 'opencartorders2_0_sendmanualsms';
        } else {
            $name_delivery = 'opencartorders2_0_changeorderstatus';
        }
        
        if ($abonent) {
            $param = array(
                'security' => array('login' => $this->username, 'password' => $this->password),
                'type' => 'sms',
                'message' => array(
                    array(
                        'type' => 'sms',
                        'name_delivery' => $name_delivery,
                        'sender' => $this->from,
                        'text' => $this->message_targetsms,
                        'abonent' => $abonent
                    )
                )
            );
           
            $param_json = json_encode($param, true);
            // JSON-документ
            $href = 'https://sms.targetsms.ru/sendsmsjson.php'; // адрес сервера
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json','charset=utf8','Expect:'));
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $param_json);
            curl_setopt($ch, CURLOPT_TIMEOUT, 600);
            curl_setopt($ch, CURLOPT_URL, $href);
            curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
            curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
            $res = curl_exec($ch);
            $result = json_decode($res, true);
            curl_close($ch);
            
        }           
        
    }


    private function validatePhone($phone) {
        
        $phone = str_replace(")","",$phone);
        $phone = str_replace("(","",$phone);
        $phone = str_replace("-","",$phone);
        $phone = str_replace(" ","",$phone);
        $phone = str_replace("+","",$phone);

        $first_3 = substr($phone,0,3);
        $first_1 = substr($phone,0,1);
        $error = 0;

        if (($first_3 == '380') || ($first_3 == '375')) {
            $last = substr($phone,3);
            if (strlen($last) == 9) {
                $phone = "+" . $phone;
            } else {
                $error = 1;
            }
            
        } elseif ($first_1 == '7') {
            $last = substr($phone,1);
            if (strlen($last) == 10) {
                $phone = "+" . $phone;
            } else {
                $error = 1;
            }

        } elseif ($first_1 == '8') {
            $last = substr($phone,1);
            if (strlen($last) == 10) {
                $phone = "+7" . $last;
            } else {
                $error = 1;
            }
        } else {
            $error = 1;
        }

        if (!$error) {
            return $phone; 
        } else {
            return false; 
        }
        
    }

}
?>